<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../../mixins';

export default Vue.extend({
  name: 'CaseStudyCarousel',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      visibleCaseStudy: 0,
    };
  },
  methods: {
    goToNext() {
      if (this.visibleCaseStudy >= this.data.case_studies.length - 1) {
        this.visibleCaseStudy = 0;
      } else {
        this.visibleCaseStudy++;
      }
    },
    goToPrev() {
      if (this.visibleCaseStudy === 0) {
        this.visibleCaseStudy = this.data.case_studies.length - 1;
      } else {
        this.visibleCaseStudy--;
      }
    },
    selectNewSlide(index) {
      this.visibleCaseStudy = index;
    },
  },
});
</script>

<i18n>
{
  "en": {
    "cta_text": "Read Case Study"
  },
  "ja": {
    "cta_text": "ケーススタディを読む"
  },
  "fr": {
    "cta_text": "Lire l'étude de cas"
  },
  "de": {
    "cta_text": "Fallstudie lesen"
  }
}
</i18n>

<template>
  <section
    :id="data.id"
    class="section"
    aria-roledescription="carousel"
    aria-label="Education Case Studies Carousel"
  >
    <SlpContainer class="wrapper">
      <SlpTypography
        v-if="data.header"
        variant="heading2-bold"
        tag="h3"
        class="slp-mb-32"
        >{{ data.header }}</SlpTypography
      >
      <div :class="{ 'cta-container': data.customers_cta }">
        <div ref="scroll" class="logos">
          <button
            v-for="(logo, index) in data.case_studies"
            :key="logo.logo_url"
            type="button"
            :aria-label="`Select ${logo.institution_name} case study`"
            :tabindex="index === visibleCaseStudy ? '-1' : 0"
            class="logo"
            :class="index === visibleCaseStudy ? 'active' : ''"
            :aria-selected="index === visibleCaseStudy"
            @click="selectNewSlide(index)"
          >
            <img :src="logo.logo_url" alt="" aria-label="" />
          </button>
        </div>
        <SlpButton
          v-if="data.customers_cta && !isMobile"
          class="cta"
          :href="data.cta?.href ?? '/customers/'"
          :data-ga-name="data.cta?.data_ga_name ?? 'customers'"
          :data-ga-location="data.cta?.data_ga_location ?? 'body'"
          variant="tertiary"
          >{{ data.cta?.text ?? 'View more stories' }}
          <SlpIcon variant="product" name="chevron-lg-right"
        /></SlpButton>
      </div>
      <div class="case-studies">
        <transition name="fade" mode="out-in" tag="div">
          <div :key="visibleCaseStudy" class="case-studies__card">
            <SlpRow
              class="card-row"
              aria-roledescription="slide"
              :aria-label="`${visibleCaseStudy} of ${data.case_studies.length}`"
            >
              <SlpColumn
                v-if="data.case_studies[visibleCaseStudy].img_url"
                :cols="6"
              >
                <img
                  loading="lazy"
                  :src="data.case_studies[visibleCaseStudy].img_url"
                  alt=""
                  class="slide-image"
                />
              </SlpColumn>
              <SlpColumn
                :cols="data.case_studies[visibleCaseStudy].img_url ? 6 : 12"
                class="content"
              >
                <figure class="text-block">
                  <img
                    v-if="data.logo_in_card"
                    class="slp-mb-16"
                    :src="data.case_studies[visibleCaseStudy].logo_url"
                  />
                  <div
                    v-if="data.case_studies[visibleCaseStudy].quote"
                    class="quote"
                  >
                    <SlpIcon variant="marketing" name="quote" size="md" />
                    <SlpTypography variant="quotes" tag="blockquote">
                      {{
                        data.case_studies[visibleCaseStudy].quote.quote_text
                      }}"
                    </SlpTypography>
                    <SlpTypography variant="body3" tag="figcaption">
                      <strong>{{
                        data.case_studies[visibleCaseStudy].quote.author
                      }}</strong>
                      <span>
                        {{
                          data.case_studies[visibleCaseStudy].quote.author_title
                        }}
                      </span>
                    </SlpTypography>
                  </div>
                  <div
                    v-else-if="data.case_studies[visibleCaseStudy].text"
                    class="text"
                  >
                    <SlpTypography variant="heading4-bold">
                      {{
                        data.case_studies[visibleCaseStudy].text
                      }}</SlpTypography
                    >
                  </div>
                </figure>
                <SlpButton
                  v-show="data.case_studies[visibleCaseStudy].case_study_url"
                  variant="tertiary"
                  :href="data.case_studies[visibleCaseStudy].case_study_url"
                  :data-ga-name="
                    data.case_studies[visibleCaseStudy].data_ga_name
                  "
                  :data-ga-location="
                    data.case_studies[visibleCaseStudy].data_ga_location
                  "
                  >{{ $t('cta_text') }}
                  <SlpIcon variant="product" name="chevron-lg-right"
                /></SlpButton>
              </SlpColumn>
            </SlpRow>
          </div>
        </transition>

        <SlpRow v-if="data.case_studies.length > 1" class="controls">
          <SlpButton
            variant="icon"
            aria-label="View previous case study"
            @click.native="goToPrev"
          >
            <SlpIcon
              name="chevron-lg-left"
              alt="Chevron Left Icon"
              variant="product"
              hex-color="#171321"
            />
          </SlpButton>
          <div class="controls__pages">
            <div
              v-for="(option, index) in data.case_studies.length"
              :key="option"
              :class="[
                option === visibleCaseStudy + 1
                  ? 'controls__pages-control--active'
                  : '',
                'controls__pages-control',
              ]"
              @click="selectNewSlide(index)"
            ></div>
          </div>
          <SlpButton
            variant="icon"
            aria-label="View next case study"
            @click.native="goToNext"
          >
            <SlpIcon
              name="chevron-lg-right"
              alt="Chevron Right Icon"
              variant="product"
              hex-color="#171321"
            />
          </SlpButton>
        </SlpRow>
        <SlpButton
          v-if="isMobile"
          class="cta slp-mt-24"
          :href="data.cta?.href ?? '/customers/'"
          :data-ga-name="data.cta?.data_ga_name ?? 'customers'"
          :data-ga-location="data.cta?.data_ga_location ?? 'body'"
          variant="tertiary"
          >{{ data.cta?.text ?? 'View more stories' }}
          <SlpIcon variant="product" name="chevron-lg-right"
        /></SlpButton>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.section {
  min-width: 100%;
  position: relative;
}

.cta-container {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  .logos .logo img {
    max-width: 150px;
  }

  .cta {
    margin-bottom: $spacing-16;
    text-align: left;
  }
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
  }
}
.wrapper {
  padding: 0 0 $spacing-32;
  @media (max-width: $breakpoint-md) {
    padding: 0 0 $spacing-48;
  }
}

.logos {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: $spacing-32;
  @media (max-width: $breakpoint-md) {
    overflow-x: scroll;
    -ms-overflow-style: none; /* Internet Explorer 10+ */
    scrollbar-width: none; /* Firefox */

    &::-webkit-scrollbar {
      display: none; /* Safari and Chrome */
    }
  }
}

.logo {
  flex: 0 0 130px;
  min-height: 85px;
  width: 100%;
  border-bottom: 1px solid transparent;
  border-top: none;
  border-left: none;
  border-right: none;
  cursor: pointer;

  @media (max-width: $breakpoint-md) {
    flex: 0 0 80px;
    aspect-ratio: 3/2;
    object-fit: contain;
  }

  &:hover {
    border-bottom: 1px solid $color-accent-500;
  }

  &.active {
    border-bottom: 1px solid $color-surface-700;
  }

  img {
    margin-bottom: 4px;
    -webkit-transform: translate3d(0, 0, 0);
    transform: translate3d(0, 0, 0);
    max-width: 100%;
    max-height: 85px;
  }
}

.case-studies {
  @media (max-width: $breakpoint-md) {
    margin: 0 $spacing-16;
  }

  &__card {
    height: 100%;
    display: flex;
    position: relative;
    flex-direction: column;
    align-items: flex-start;
    isolation: isolate;
    background: white;
    will-change: contents;

    :deep(strong) {
      font-weight: $font-weight-bold;
    }

    .slp-col-md-5,
    .slp-col-md-7 {
      height: 460px;
    }
  }

  .slp-col-md-6 {
    position: relative;
  }

  .slide-image {
    width: 100%;
    min-height: 100%;
    max-height: 460px;
    height: 100%;
    display: block;
    object-fit: cover;
    border-radius: 4px 0 0 4px;

    @media (max-width: $breakpoint-md) {
      aspect-ratio: 1.5/1;
      min-height: 0;
      max-height: 400px;
    }
  }

  .content {
    background: $color-surface-800;
    padding: $spacing-32;
    border-radius: 0 4px 100px 0;
    display: flex;
    flex-direction: column;

    figcaption {
      margin-top: $spacing-8;
      margin-bottom: $spacing-24;
    }

    span {
      display: block;
    }

    .slp-btn {
      max-width: 200px;
      max-height: 85px;
    }

    .slp-icon {
      margin-left: 4px;
    }
  }

  .controls {
    display: flex;
    align-items: center;
    justify-content: center;
    margin-top: $spacing-24;

    color: #171321;

    :deep {
      svg,
      path {
        fill: #171321 !important;
        stroke: #171321 !important;
      }
    }

    &__pages {
      display: inherit;

      &-control {
        background: $color-surface-300;
        border-radius: 50%;
        width: 10px;
        height: 10px;
        margin: 0 $spacing-8;
        cursor: pointer;

        &:hover {
          background: $color-accent-500;
        }

        &--active {
          background: $color-surface-700;
        }
      }
    }
  }
}

.card-row {
  @media (min-width: $breakpoint-lg) {
    min-height: 372px;
  }
}
.text-block {
  flex-basis: 100%;
}
</style>
